/////////////////////////////////////////////////
//Revolution Engine.
//by Technik
/////////////////////////////////////////////////

#ifndef REVMESH_H
#define REVMESH_H

#include "REV.h"

typedef struct REV_Mesh{//Mesh, datos de modelo 3D
u16 NVerts;//Cuantos vertices tiene nuestro modelo
u16 NFaces;//Cuantas caras tiene nuestro modelo
u16 Ncoords;//Cuantas coordenadas de textura tiene nuestro modelo
u16 NNormals;//Cuantos normales tiene nuestro modelo.
f32 * Vertices;//Puntero al array de vertices 
f32 * Normales;
f32 * Coordenadas;//Puntero al array de coordenadas de textura
u16 * VList;//Puntero a la lista de faces, compuesta por indices de vertice y textura.
u16 * NList;
u16 * TList;
} MESH;

/****** REV_SetDefCLR ******
Descripcion: Cambia el color de base con el que se crean los objetos por defecto.
Argumentos : Nuevo color por defecto
Devuelve: Nada */

void scaleMesh(MESH* mesh, f32 x, f32 y, f32 z);

void REV_SetDefCLR(GXColor Color);

GXColor REV_GetDefCLR(void);

MESH * AbrirMesh(const char * filename);

void MESH_LOG(MESH * mesh);

#endif
