/////////////////////////////////////////////////
//Revolution Engine.
//by Technik
/////////////////////////////////////////////////

#ifndef REV_PHYSICS_H
#define REV_PHYSICS_H

#define MIN_SPEED 0.1
#define MIN_ACCEL 0.01
#define MIN_ANG_SPEED 0.1
#define MIN_ANG_ACCEL 0.1

#define Phantom 0
#define Static 1
#define Dynamic 2
#define Manual 4

#define Radius fparam1
#define Width fparam1
#define Length fparam2
#define Height fparam3

#define Point 0
#define Sphere 1
#define Box 2

#define check 0
#define lock 1
#define recalculate 2

typedef struct REV_Body{
u8 type;
f32 mass, bouncy, friction;
f32 fparam1, fparam2, fparam3;
}BODY;

typedef 
struct REV_Ph{
u8 mode;
Vector Pos, Spd, ASp; //Posicion, velocidad y velocidad angular;
Mtx modMtx;//La matriz de posicion y orientacion en el espacio.
}PHSTATE;

f32 VecModule(Vector a);
f32 VecSqModule(Vector a);

///////////
void setTimeSpeed(f32 speed);

BODY * PointBD(f32 bouncy, f32 friction);

BODY * BoxBD(f32 Width, f32 Length,f32 Height, f32 bouncy, f32 friction);

BODY * SphereBD(f32 Radius, f32 bouncy, f32 friction);
///////////

//Devuelve el numero de iteraciones que se han usado para el calculo.
u8 PhysicsUpdate(ROOT * root);

//Devuelve 1 si hay colision, 0 si no la hay
u8 collide(OBJECT * A, OBJECT * B);

void setSpeed(OBJECT* object, Vector Linear, Vector Angular);

//Actualiza el estado fisico del objeto
void UpdateState(OBJECT * object);

f32 valAbs(f32 src);

f32 gameTime();

f32 frameTime();

void UpdtTime();

#endif
