/////////////////////////////////////////////////
//Revolution Engine.
//by Technik
/////////////////////////////////////////////////
#ifndef REV_SCREEN_H
#define REV_SCREEN_H

#define visible 1

#define PanelT 1
#define TextT  2

/*all these screen structures begin the same way
for the ordered queue to work properly*/
typedef struct REV_Panel{
void * next;
u8 type, layer, flags, Visible;
GXTexObj * img;
f32 x, y, xstart, xend, ystart, yend, sizeX, sizeY;
f32 angle;
}PANEL;//25 bytes

typedef struct REV_Text{
void * next;
u8 type, layer, flags, Visible;
u8 size;//in pixels
u8 startline, displaylines;
f32 x, y, angle, sizeX, sizeY;
char content[256];
GXTexObj * rast;//the rasterized text image
GXColor color;
}TEXT;

void update2D();

void drawPnl(PANEL * panel);

struct REV_Panel * newPanel(GXTexObj * img, f32 xPos, f32 yPos, u16 sizeX, u16 sizeY, u8 layer, u8 flags);

struct REV_Text * newText(char * content, f32 x, f32 y, GXColor Color, u8 size, u8 layer, u8 flags);

void addPnl(PANEL * panel);

void rastText(TEXT * text);

GXTexObj * tile4x4Tex(void * mem, int tx, int ty);

char ** segmentText(TEXT * text, u8 * lines);

GXColor REV_PeekARGB( u16 x, u16 y);

#endif
