/////////////////////////////////////////////////
//Revolution Engine.
//by Technik
/////////////////////////////////////////////////

#include "REV.h"

static void *frameBuffer[2] = { NULL, NULL};
GXRModeObj *rmode;
Mtx view; // view Matrix
Mtx model, modelview;
f32 w, h;
Mtx perspective;

u32	fb = 0; 	// initial framebuffer index
GXColor background = {0, 0, 0, 0xff};

ROOT * mainRoot;

f32 Panel2D[] ATTRIBUTE_ALIGN(32) =//coordenadas de texturas predefinidas
{
	0.0f,0.0f,
	1.0f,0.0f,
	1.0f,1.0f,
	0.0f,1.0f,
};

void REV_Init()
{	
	f32 yscale;
	u32 xfbHeight;
	
	u32	fb = 0; 	// initial framebuffer index
	GXColor background = {0, 0, 0, 0xff};
	
	rmode = VIDEO_GetPreferredMode(NULL);
	
	// allocate 2 framebuffers for double buffering
	frameBuffer[0] = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	frameBuffer[1] = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));

	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(frameBuffer[fb]);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

	//fat init default
	fatInitDefault ();
	// setup the fifo and then init the flipper
	void *gp_fifo = NULL;
	gp_fifo = memalign(32,DEFAULT_FIFO_SIZE);
	memset(gp_fifo,0,DEFAULT_FIFO_SIZE);
 
	GX_Init(gp_fifo,DEFAULT_FIFO_SIZE);
 
	// clears the bg to color and clears the z buffer
	GX_SetCopyClear(background, 0x00ffffff);
	
	GX_SetViewport(0,0,rmode->fbWidth,rmode->efbHeight,0,1);
	yscale = GX_GetYScaleFactor(rmode->efbHeight,rmode->xfbHeight);
	xfbHeight = GX_SetDispCopyYScale(yscale);
	GX_SetScissor(0,0,rmode->fbWidth,rmode->efbHeight);
	GX_SetDispCopySrc(0,0,rmode->fbWidth,rmode->efbHeight);
	GX_SetDispCopyDst(rmode->fbWidth,xfbHeight);
	GX_SetCopyFilter(rmode->aa,rmode->sample_pattern,GX_TRUE,rmode->vfilter);
	GX_SetFieldMode(rmode->field_rendering,((rmode->viHeight==2*rmode->xfbHeight)?GX_ENABLE:GX_DISABLE));
 
	GX_SetCullMode(GX_CULL_BACK);
	GX_CopyDisp(frameBuffer[fb],GX_TRUE);
	GX_SetDispCopyGamma(GX_GM_1_0);
	
	w = rmode->viWidth;
    h = rmode->viHeight;
	draw3D_init();
	
	GX_SetViewport(0,0,rmode->fbWidth,rmode->efbHeight,0,1);
	GX_SetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
	GX_SetColorUpdate(GX_ENABLE);
	GX_SetAlphaUpdate(GX_ENABLE);
	GX_SetZCompLoc(GX_FALSE);
	//Hasta aqui es todo inicializacion rutinaria de las GX
	
	//Ahora la correspondiente al engine
	mainRoot = newRoot();
	RevFTInit();//Las FreeType
}

void draw3D_init()
{
	GX_ClearVtxDesc();
	GX_InvalidateTexAll();
	
	GX_SetVtxDesc(GX_VA_POS, GX_INDEX16);
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
 	
	GX_SetVtxDesc(GX_VA_NRM, GX_INDEX16);
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_NRM, GX_NRM_XYZ, GX_F32, 0);
 	
	GX_SetVtxDesc(GX_VA_CLR0, GX_DIRECT);
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
 	
	GX_SetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);
	
	
	GX_SetZMode (GX_TRUE, GX_LEQUAL, GX_TRUE);
	////////////TEV
	GX_SetNumTevStages(1);//We only use one cycle of texture enviroment
	GX_SetNumChans(1);
	GX_SetNumTexGens(1);
	GX_SetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	GX_SetTevOp(GX_TEVSTAGE0, GX_MODULATE);
	///////////////
	guPerspective(perspective, 45, (f32)w/h, 0.01F, 10000.0F);
	GX_LoadProjectionMtx(perspective, GX_PERSPECTIVE);
}

void draw2D_init()
{
	GX_ClearVtxDesc();
	GX_InvalidateTexAll();
	GX_SetVtxDesc(GX_VA_POS, GX_DIRECT);
 	GX_SetVtxDesc(GX_VA_CLR0, GX_DIRECT);
 	GX_SetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);
	
	GX_SetZMode (GX_FALSE, GX_LEQUAL, GX_TRUE);
	GX_SetNumChans(1);
	GX_SetNumTexGens(1);
	GX_SetNumTevStages(1);
	GX_SetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	GX_SetTevOp(GX_TEVSTAGE0, GX_MODULATE);
	
	guOrtho(perspective,0,480,0,639,1.0,300.0);
	GX_LoadProjectionMtx(perspective, GX_ORTHOGRAPHIC);
}

void REV_Render(OBJECT * object)
{
	MESH * tMesh;
	MD5modelo * tmd5;
	MD5union *Esqueleto = NULL;
	MD5mesh *mesh5;
	MATERIAL * tMat;
	MD5anim *anim = NULL;
	GXTexObj * textura1;
	u32 i=0, j=0;
	u8 R,G,B,A;
	R = object->baseColor.r;
	G = object->baseColor.g;
	B = object->baseColor.b;
	A = object->baseColor.a;
	f32 utile = 1.0, vtile = 1.0;
	if(object->Visible)
	{
		if(object->Mesh)
		{
			tMesh = object->Mesh;
			draw3D_init();
			if(object->Material && object->Material->Textura)
			{
				GX_SetTevOp(GX_TEVSTAGE0, GX_MODULATE);
					tMat = object->Material;
				textura1 = object->Material->Textura;
				GX_LoadTexObj(textura1, GX_TEXMAP0);
				utile = tMat->utile;
				vtile = tMat->vtile;
			}
			else
			{
				GX_SetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
			}
			guMtxConcat(view,object->State->modMtx,modelview);
			GX_LoadPosMtxImm(modelview, GX_PNMTX0);
			
			GX_SetArray(GX_VA_POS, tMesh->Vertices, 3*sizeof(f32));
			GX_SetArray(GX_VA_NRM, tMesh->Normales, 3*sizeof(f32));
			
			GX_Begin(GX_TRIANGLES, GX_VTXFMT0, 3*tMesh->NFaces);
			
			for(i=0; i<tMesh->NFaces; i++)
			{
				GX_Position1x16(tMesh->VList[i*3]);
				GX_Normal1x16(tMesh->NList[i*3]);
				GX_Color4u8(R,G,B,A);
				GX_TexCoord2f32(tMesh->Coordenadas[2*tMesh->TList[i*3]]*utile,
								tMesh->Coordenadas[2*tMesh->TList[i*3]+1]*vtile);
				
				GX_Position1x16(tMesh->VList[(i*3)+1]);
				GX_Normal1x16(tMesh->NList[(i*3)+1]);
				GX_Color4u8(R,G,B,A);
				GX_TexCoord2f32(tMesh->Coordenadas[2*tMesh->TList[(i*3)+1]]*utile,
								tMesh->Coordenadas[2*tMesh->TList[(i*3)+1]+1]*vtile);
				
				GX_Position1x16(tMesh->VList[(i*3)+2]);
				GX_Normal1x16(tMesh->NList[(i*3)+2]);
				GX_Color4u8(R,G,B,A);
				GX_TexCoord2f32(tMesh->Coordenadas[2*tMesh->TList[(i*3)+2]]*utile,
								tMesh->Coordenadas[2*tMesh->TList[(i*3)+2]+1]*vtile);
			}
			GX_End();
		}
		if(object->Md5)
		{
			anim = NULL;
			tmd5 = object->Md5;
			if ( tmd5->num_animaciones > 0 )	// Hay animaciones
			{
				// Apuntamos a la primera animacin ( puedes apuntar a la que te salga xD )
				anim = &tmd5->animacion[0];
			}
			GX_ClearVtxDesc();
			GX_InvalidateTexAll();
			GX_SetVtxDesc(GX_VA_POS, GX_DIRECT);
			GX_SetVtxDesc(GX_VA_CLR0, GX_DIRECT);
			GX_SetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	
			GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
			GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
			GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);
	
			GX_SetNumChans(1);
			GX_SetNumTexGens(1);
			GX_SetNumTevStages(1);
			GX_SetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
			GX_SetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
			////////////////
			guMtxConcat(view,object->State->modMtx,modelview);
			GX_LoadPosMtxImm(modelview, GX_PNMTX0);
			if ( anim )
			{
				// Calcula el frame actual y siguiente
				Animar (anim, tmd5->Infoanim, gameTime());

					// Reservamos memoria para el Esqueleto
					Esqueleto = (MD5union*)memalign(32, sizeof(MD5union));

					// Interpolamos el Esqueleto entre dos frames
					InterpolarEsqueletos (anim->EsqueletoFrames[tmd5->Infoanim->curr_frame],
								anim->EsqueletoFrames[tmd5->Infoanim->next_frame],
								anim->num_uniones,
								tmd5->Infoanim->last_time * anim->frameRate,
								Esqueleto);
			}
			else	// No hay animaciones
			{
				Esqueleto = tmd5->baseEsqueleto;
			}
			for(i=0;i<tmd5->num_meshes;i++)//We draw each mesh in the model
			{
				mesh5 = &(tmd5->meshes[i]);
				PrepararMD5 ( mesh5, Esqueleto );
				GX_Begin(GX_TRIANGLES, GX_VTXFMT0, 3*mesh5->num_triangulos);
				for(j=0;j<mesh5->num_triangulos;j++)
				{
				GX_Position3f32(mesh5->Verts[((mesh5->VIndices[j*3])*3)],
								mesh5->Verts[((mesh5->VIndices[j*3])*3)+1],
								mesh5->Verts[((mesh5->VIndices[j*3])*3)+2]);
				GX_Color4u8(R,G,B,A);
				GX_TexCoord2f32(0,0);
				
				GX_Position3f32(mesh5->Verts[((mesh5->VIndices[j*3+1])*3)],
								mesh5->Verts[((mesh5->VIndices[j*3+1])*3)+1],
								mesh5->Verts[((mesh5->VIndices[j*3+1])*3)+2]);
				GX_Color4u8(R,G,B,A);
				GX_TexCoord2f32(0,0);
				
				GX_Position3f32(mesh5->Verts[((mesh5->VIndices[j*3+2])*3)],
								mesh5->Verts[((mesh5->VIndices[j*3+2])*3)+1],
								mesh5->Verts[((mesh5->VIndices[j*3+2])*3)+2]);
				GX_Color4u8(R,G,B,A);
				GX_TexCoord2f32(0,0);
				}
				GX_End();
			}
			if ( Esqueleto )	// Hay animaciones
					free (Esqueleto);
		}
	}
}

void REV_Process(CAMERA * mCamara)
{
	OBJECT * Auxiliar;
	UpdtCam(*mCamara, view);
	UpdtTime();
	PhysicsUpdate(mainRoot);
	
	Auxiliar = mainRoot->StcObj;
	while(Auxiliar)
	{
		REV_Render(Auxiliar);
		Auxiliar = Auxiliar->Next;
	}
	Auxiliar = mainRoot->DyUObj;
	while(Auxiliar)
	{
		REV_Render(Auxiliar);
		Auxiliar = Auxiliar->Next;
	}
	Auxiliar = mainRoot->DyAObj;
	while(Auxiliar)
	{
		REV_Render(Auxiliar);
		Auxiliar = Auxiliar->Next;
	}
	Auxiliar = mainRoot->PhnObj;
	while(Auxiliar)
	{
		REV_Render(Auxiliar);
		Auxiliar = Auxiliar->Next;
	}
	Auxiliar = mainRoot->ElsObj;
	while(Auxiliar)
	{
		REV_Render(Auxiliar);
		Auxiliar = Auxiliar->Next;
	}
	
	//Ahora va la implementacion del 2D, justo antes de copiar el EFB al XFB para aprovechar la conversion RGB ;)
	draw2D_init();
	update2D();
	//reajustar los parametros iniciales
	draw3D_init();
	GX_DrawDone();
	
	fb ^= 1;		// flip framebuffer
	GX_SetColorUpdate(GX_TRUE);
	GX_CopyDisp(frameBuffer[fb],GX_TRUE);

	VIDEO_SetNextFramebuffer(frameBuffer[fb]);
 
	VIDEO_Flush();

	VIDEO_WaitVSync();
}

ROOT * newRoot()
{
	ROOT * root = (ROOT*)malloc(sizeof(ROOT));
	root->PhnObj = NULL;//Lista de objetos fantasma
	root->StcObj = NULL;//Lista de objetos estaticos
	root->DyUObj = NULL;//Lista de objetos dinamicos inactivos
	root->DyAObj = NULL;//Lista de objetos dinamicos activos
	root->ManObj = NULL;//Lista de objetos animados de forma manual
	root->ElsObj = NULL;//Lista con todos los objetos que carecen de Body
	root->FstPnl = NULL;//Lista de paneles
	return root;
}

void DelRoot(ROOT * root)
{
	clearRoot(root);
	free(root);
}

void addObj(OBJECT * object)
{
	if(!object->Body)
	{
		object->Next = mainRoot->ElsObj;
		mainRoot->ElsObj = object;
	}
	else{
		switch(object->State->mode)
		{
			case Static:
				object->Next = mainRoot->StcObj;
				mainRoot->StcObj = object;
				break;
			case Dynamic:
				object->Next = mainRoot->DyAObj;
				mainRoot->DyAObj = object;
				break;
			case Manual:
				object->Next = mainRoot->ManObj;
				mainRoot->ManObj = object;
			default:
				object->Next = mainRoot->PhnObj;
				mainRoot->PhnObj = object;
				break;
		}
	}
}

OBJECT * NewObj(MESH * mesh, MATERIAL * material, BODY * Body, Vector Pos, Vector Ang, u8 Visible)
{
	Mtx Aux;
	OBJECT * Objeto = (OBJECT*)malloc(sizeof(OBJECT));
	Objeto->Mesh = mesh;
	Objeto->Next = NULL;
	Objeto->State = (PHSTATE*)malloc(sizeof(PHSTATE));
	Objeto->State->Pos = Pos;
	Objeto->State->Spd = (Vector){0.0, 0.0, 0.0};
	Objeto->State->ASp = (Vector){0.0, 0.0, 0.0};
	Objeto->State->mode = Static;
	Objeto->Material = material;
	Objeto->Body = Body;
	Objeto->baseColor = REV_GetDefCLR();
	Objeto->Visible = Visible;
	Objeto->Md5 = NULL;
	
	guMtxIdentity(Objeto->State->modMtx);
	guMtxRotDeg(Aux, 'y', Ang.y);
	guMtxConcat(Aux, Objeto->State->modMtx, Objeto->State->modMtx);
	guMtxRotDeg(Aux, 'x', Ang.x);
	guMtxConcat(Aux, Objeto->State->modMtx, Objeto->State->modMtx);
	guMtxRotDeg(Aux, 'z', Ang.z);
	guMtxConcat(Aux, Objeto->State->modMtx, Objeto->State->modMtx);
	guMtxTransApply(Objeto->State->modMtx, Objeto->State->modMtx, Pos.x, Pos.y, Pos.z);
	
	addObj(Objeto);
	return Objeto;
}

u8 RemoveObjFromList(OBJECT * List, OBJECT * object)
{
	if(object)
	while(List)
	{
		if(List->Next == object)
		{
			List->Next = object->Next;
			object->Next = NULL;
			return 1;//Se ha eliminado un objeto
		}
		List = List->Next;
	}
	return 0;//No se ha eliminado ningun objeto
}

void AddObjToList(OBJECT * List, OBJECT * object)
{
	object->Next = List;
	List = object;
}

void FreeObj(OBJECT * object)
{
	free(object->State);
	free(object);
}

void clearRoot(ROOT * root)
{
	OBJECT * Auxiliar;
	PANEL * Aux;
	Auxiliar = root->ElsObj;
	while(Auxiliar)
	{
		root->ElsObj = root->ElsObj->Next;
		FreeObj(Auxiliar);
		Auxiliar = root->ElsObj;
	}
	Auxiliar = root->PhnObj;
	while(Auxiliar)
	{
		root->PhnObj = root->PhnObj->Next;
		FreeObj(Auxiliar);
		Auxiliar = root->PhnObj;
	}
	Auxiliar = root->StcObj;
	while(Auxiliar)
	{
		root->StcObj = root->StcObj->Next;
		FreeObj(Auxiliar);
		Auxiliar = root->StcObj;
	}
	Auxiliar = root->DyUObj;
	while(Auxiliar)
	{
		root->DyUObj = root->DyUObj->Next;
		FreeObj(Auxiliar);
		Auxiliar = root->DyUObj;
	}
	Auxiliar = root->DyAObj;
	while(Auxiliar)
	{
		root->DyAObj = root->DyAObj->Next;
		FreeObj(Auxiliar);
		Auxiliar = root->DyAObj;
	}
	Aux = root->FstPnl;
	while(Aux)
	{
		root->FstPnl = Aux->next;
		free(Aux);
		Aux = root->FstPnl;
	}
}
