/////////////////////////////////////////////////
//Revolution Engine.
//by Technik
/////////////////////////////////////////////////

#include "REV.h"

/*** Globals ***/
FT_Library ftlibrary;
FT_Face face;
FT_GlyphSlot slot;

GXColor fontColor = (GXColor){120,120,255,255};

/*** The actual TrueType Font ***/
extern char fontface[];		/*** From fontface.s ***/
extern int fontsize;			/*** From fontface.s ***/

/*** File listings ***/
extern u8 filelist[1024][1024];
extern u32 maxfile;
#define PAGESIZE 18

u8 RevFTInit()
{
	if(FT_Init_FreeType (&ftlibrary))//Si devuelve algun error la inicializacion
		return 1;//salimos
	if(FT_New_Memory_Face (ftlibrary, (FT_Byte *) fontface, fontsize, 0, &face))//si devuelve error
		return 1;//salimos
	setfontsize (16);
	
	slot = face->glyph;
	
	return 0;
}

void setfontsize (u32 pixels)
{
	FT_Set_Pixel_Sizes (face, 0, pixels);
}


void setfontcolour (u8 r, u8 g, u8 b)
{
	fontColor = (GXColor){r,g,b,255};
}

static void DrawCharacter (FT_Bitmap * bmp, u16 x, u16 y)
{
	u16 i, j, p, q;
	u16 x_max = x + bmp->width;
	u16 y_max = y + bmp->rows;
	GXColor pixel;//
	u32 src;
	
	for (i = x, p = 0; i < x_max; i++, p++)
	{
		for (j = y, q = 0; j < y_max; j++, q++)
		{
			src = bmp->buffer[q * bmp->width + p];
			pixel = (GXColor)(*((GXColor*)&src));
			if(pixel.a)
			GX_PokeARGB(i,j,fontColor);
		}
	}
}

/**
 * DrawText
 *
 * Place the font bitmap on the screen
 */
void DrawText (int x, int y, char *text)
{
  int px, n;
  int i;
  int value, count;

  n = strlen (text);
  if (n == 0)
    return;

	/*** x == -1, auto centre ***/
  if (x == -1)
    {
      value = 0;
      px = 0;
    }
  else
    {
      value = 1;
      px = x;
    }

  for (count = value; count < 2; count++)
    {
		/*** Draw the string ***/
      for (i = 0; i < n; i++)
	{
	  

	  if (FT_Load_Char (face, text[i], FT_LOAD_RENDER))
	      continue;				/*** Skip unprintable characters ***/

	  if (count)
	    DrawCharacter (&slot->bitmap, px + slot->bitmap_left,
			   y - slot->bitmap_top);

	  px += slot->advance.x >> 6;
	}

      px = (640 - px) >> 1;

    }
}
