/////////////////////////////////////////////////
//Revolution Engine.
//by Technik
/////////////////////////////////////////////////

#include "REV.h"

#define TEMP_SIZE     65536
#define MAXLINE 60
#define LoaderVersion 0.1

GXColor REV_DefaultColor = (GXColor){192,192,192,255};

void REV_SetDefCLR(GXColor Color)
{
	REV_DefaultColor = Color;
}

GXColor REV_GetDefCLR(void)
{
	return REV_DefaultColor;
}

void scaleMesh(MESH* mesh, f32 x, f32 y, f32 z)
{
	u16 i;
	for(i = 0;i< mesh->NVerts;i++)
	{
		mesh->Vertices[i*3] *= x;
		mesh->Vertices[(i*3)+1] *= y;
		mesh->Vertices[(i*3)+2] *= z;
	}
}

MESH * AbrirMesh(const char * filename)
{
	MESH * Nuevo = (MESH*)memalign(0x20,sizeof(MESH));
	if(!Nuevo) return NULL;
	FILE * modelfile = fopen(filename, "rt");
	if(!modelfile){
		free(Nuevo);
		return NULL;
	}
	char linebuffer[MAXLINE];
	char * datatype;
	f32 version = 0;
	u16 verts = 0, texts = 0, normals = 0, faces = 0;
	
	Nuevo->NVerts = 0;
	Nuevo->NNormals = 0;
	Nuevo->Ncoords = 0;
	Nuevo->NFaces = 0;
	
	//Una vez declarado todo lo que vamos a usar empezamos a explorar el archivo.
	while(!feof(modelfile))
	{
		fgets(linebuffer, MAXLINE, modelfile);
		if(!feof(modelfile))
		{
			datatype = strtok(linebuffer," ");
			if(datatype[0] != '#')//Si una linea empieza por # es que es un comentario, por tanto no se procesa
			{//En caso contrario
				if(datatype[0] == 'm')//Estamos ante la informacion de version de archivo
				{
					version = atof(strtok(NULL, " "));
				}
				if(datatype[0] == 'q')
				{
					if(datatype[1] == 'v')
					{
						Nuevo->NVerts = atoi(strtok(NULL, " "));
						Nuevo->Vertices = (f32*)memalign(32, Nuevo->NVerts*sizeof(f32)*3);
					}
					if(datatype[1] == 'n')
					{
						Nuevo->NNormals = atoi(strtok(NULL, " "));
						Nuevo->Normales = (f32*)memalign(32, Nuevo->NNormals*sizeof(f32)*3);
					}
					if(datatype[1] == 't')
					{
						Nuevo->Ncoords = atoi(strtok(NULL, " "));
						Nuevo->Coordenadas = (f32*)memalign(32, Nuevo->Ncoords*sizeof(f32)*2);
					}
					if(datatype[1] == 'f')
					{
						Nuevo->NFaces = atoi(strtok(NULL, " "));
						Nuevo->VList = (u16*)memalign(32, Nuevo->NFaces*sizeof(u16)*3);
						Nuevo->NList = (u16*)memalign(32, Nuevo->NFaces*sizeof(u16)*3);
						Nuevo->TList = (u16*)memalign(32, Nuevo->NFaces*sizeof(u16)*3);
					}
				}
				if(datatype[0] == 'v')
				{if(verts < Nuevo->NVerts){
					Nuevo->Vertices[verts*3] = (f32)atof(strtok(NULL, " "));
					Nuevo->Vertices[verts*3+1] = (f32)atof(strtok(NULL, " "));
					Nuevo->Vertices[verts*3+2] = (f32)atof(strtok(NULL, " "));
					verts ++;
				}}
				if(datatype[0] == 'n')
				{if(normals < Nuevo->NNormals){
					Nuevo->Normales[normals*3] = (f32)atof(strtok(NULL, " "));
					Nuevo->Normales[normals*3+1] = (f32)atof(strtok(NULL, " "));
					Nuevo->Normales[normals*3+2] = (f32)atof(strtok(NULL, " "));
					normals ++;
				}}
				if(datatype[0] == 't')
				{ if(texts < Nuevo->Ncoords){
					Nuevo->Coordenadas[texts*2] = (f32)atof(strtok(NULL, " "));
					Nuevo->Coordenadas[texts*2+1] = (f32)atof(strtok(NULL, " "));
					texts ++;
				}}
				if(datatype[0] == 'f')
				{if(faces < Nuevo->NFaces){
					Nuevo->VList[faces*3+2] = atoi(strtok(NULL, "/"));
					Nuevo->NList[faces*3+2] = atoi(strtok(NULL, "/"));
					Nuevo->TList[faces*3+2] = atoi(strtok(NULL, " "));
					
					Nuevo->VList[faces*3+1] = atoi(strtok(NULL, "/"));
					Nuevo->NList[faces*3+1] = atoi(strtok(NULL, "/"));
					Nuevo->TList[faces*3+1] = atoi(strtok(NULL, " "));
					
					Nuevo->VList[faces*3+0] = atoi(strtok(NULL, "/"));
					Nuevo->NList[faces*3+0] = atoi(strtok(NULL, "/"));
					Nuevo->TList[faces*3+0] = atoi(strtok(NULL, " "));
					faces++;
				}}
			}
		}
	}//////*/
	fclose(modelfile);
	DCFlushRange(Nuevo->Vertices, Nuevo->NVerts*sizeof(f32)*3);
	DCFlushRange(Nuevo->Normales, Nuevo->NNormals*sizeof(f32)*3);
	DCFlushRange(Nuevo->Coordenadas, Nuevo->Ncoords*sizeof(f32)*2);
	return Nuevo;
}

void MESH_LOG(MESH * mesh)
{
	u16 i = 0;
	FILE * output;
	output = fopen("meshlog.rms", "wt");
	fprintf(output, "qv %d \n", mesh->NVerts);
	fprintf(output, "qn %d \n", mesh->NNormals);
	fprintf(output, "qt %d \n", mesh->Ncoords);
	fprintf(output, "qf %d \n", mesh->NFaces);
	for(i = 0; i < mesh->NFaces; i++)
	{
		fprintf(output, "%d %d %d \n", mesh->VList[i*3], mesh->VList[i*3+1], mesh->VList[i*3+2]);
	}
}
