/////////////////////////////////////////////////
//Revolution Engine.
//by Technik
/////////////////////////////////////////////////

#include "REV.h"

f32 frame_time = 0;
f32 current_time = 0;
f32 last_frame = 0;
f32 timeSpeed = 1.0;

//////////////////////
void setTimeSpeed(f32 speed)
{
	timeSpeed = speed;
}

f32 VecModule(Vector a)
{
	return sqrt(a.x*a.x+a.y*a.y+a.z*a.z);
}

f32 VecSqModule(Vector a)
{
	return a.x*a.x+a.y*a.y+a.z*a.z;
}

BODY * PointBD(f32 bouncy, f32 friction)
{
	BODY * Punto = (BODY*)malloc(sizeof(BODY));
	Punto->bouncy = bouncy;
	Punto->friction = friction;
	Punto->type = Point;
	Punto->mass = 0;
	return Punto;
}

BODY * BoxBD(f32 Width, f32 Length,f32 Height, f32 bouncy, f32 friction)
{
	BODY * Plano = (BODY*)malloc(sizeof(BODY));
	Plano->Width = Width;
	Plano->Length = Length;
	Plano->Height = Height;
	Plano->bouncy = bouncy;
	Plano->friction = friction;
	Plano->type = Box;
	Plano->mass = 0;
	return Plano;
}

BODY * SphereBD(f32 Radius, f32 bouncy, f32 friction)
{
	BODY * Esfera = (BODY*)malloc(sizeof(BODY));
	Esfera->Radius = Radius;
	Esfera->mass = 0;
	Esfera->bouncy = bouncy;
	Esfera->friction = friction;
	Esfera->type = Sphere;
	return Esfera;
}
//////////////////////

f32 frameTime()
{
	return frame_time;
}

f32 gameTime()
{
	return frame_time * timeSpeed;
}

u8 PhysicsUpdate(ROOT * root)
{
	OBJECT * A = root->DyAObj;
	while(A)
	{
		UpdateState(A);
		A = A->Next;
	}
	return 1;
}

void UpdateState(OBJECT * object)
{
		Mtx Aux;
		PHSTATE * acum = object->State;
		Vector Angle;
		guMtxTransApply(acum->modMtx, acum->modMtx, -acum->Pos.x, -acum->Pos.y, -acum->Pos.z);
		acum->Pos.x += acum->Spd.x * gameTime();
		acum->Pos.y += acum->Spd.y * gameTime();
		acum->Pos.z += acum->Spd.z * gameTime();
		Angle.x = acum->ASp.x * gameTime();
		Angle.y = acum->ASp.y * gameTime();
		Angle.z = acum->ASp.z * gameTime();
		guMtxRotDeg(Aux, 'y', Angle.y);
		guMtxConcat(Aux, acum->modMtx, acum->modMtx);
		guMtxRotDeg(Aux, 'x', Angle.x);
		guMtxConcat(Aux, acum->modMtx, acum->modMtx);
		guMtxRotDeg(Aux, 'z', Angle.z);
		guMtxConcat(Aux, acum->modMtx, acum->modMtx);
		guMtxTransApply(acum->modMtx, acum->modMtx, acum->Pos.x, acum->Pos.y, acum->Pos.z);
}

u8 collide(OBJECT * A, OBJECT * B)
{
	Vector RelPos, Dimension, RelSpd, Landa, Min, Max, Auxv;
	f32 tRadius, distance;
	s8 i,j,k;
	Mtx Aux;
	switch(A->Body->type)
	{
	case Point:
		switch(B->Body->type)
		{
			case Point:
				RelPos.x = A->State->Pos.x - B->State->Pos.x;
				RelPos.y = A->State->Pos.y - B->State->Pos.y;
				RelPos.z = A->State->Pos.z - B->State->Pos.z;
				RelSpd.x = A->State->Spd.x - B->State->Spd.x;
				RelSpd.y = A->State->Spd.y - B->State->Spd.y;
				RelSpd.z = A->State->Spd.x - B->State->Spd.z;
				if(RelSpd.x)
				{
					if(RelSpd.y)
					{
						if(RelSpd.z)
						{
							if(RelPos.x * RelSpd.x >= 0)
							if(RelPos.x <= gameTime()*RelSpd.x)
							if((RelPos.y*RelSpd.x == RelPos.x*RelSpd.y)&&(RelPos.z*RelSpd.x == RelPos.x*RelSpd.z))
							return 1;//Works & is optimal
						}
						else
						{
							if(RelPos.z) return 0;
							else
							{
								if(RelPos.x * RelSpd.x >= 0)
								if(RelPos.x <= gameTime()*RelSpd.x)
								if(RelPos.y*RelSpd.x == RelPos.x*RelSpd.y)
								return 1;//Works & is optimal
							}
						}
					}
					else
					{
						if(RelPos.y) return 0;
						else
						{
							if(RelSpd.z)
							{
								if(RelPos.x * RelSpd.x >= 0)
								if(RelPos.x <= gameTime()*RelSpd.x)
								if(RelPos.z*RelSpd.x == RelPos.x*RelSpd.z)
								return 1;//Works & is optimal
							}
							else
							{
								if(RelPos.z) return 0;
								else
								{
									if(RelPos.x * RelSpd.z >= 0)
									if(RelPos.x <= gameTime()*RelSpd.x)
									return 1;
								}
							}
						}
					}
				}
				else
				{
					if(RelPos.x) return 0;
					else
					{
						if(RelSpd.y)
						{
							if(RelSpd.z)
							{
								if(RelPos.z*RelSpd.z >= 0)
								if(RelPos.z <= gameTime()*RelSpd.z)
								if(RelPos.y*RelSpd.z == RelPos.z*RelSpd.y)
								return 1;
							}
							else
							{
								if(RelPos.z) return 0;
								else
								{
									if(RelPos.y * RelSpd.z >= 0)
									if(RelPos.y <= gameTime()*RelSpd.y) return 1;
								}
							}
						}
						else
						{
							if(RelPos.y) return 0;
							else
							{
								if(RelSpd.z)
								{
									if(RelPos.z * RelSpd.z >= 0)
									if(RelPos.z <= gameTime()*RelSpd.z) return 1;
								}
							}
						}
					}
				}
				return 0;
			case Sphere:
				RelPos.x = A->State->Pos.x - B->State->Pos.x;
				RelPos.y = A->State->Pos.y - B->State->Pos.y;
				RelPos.z = A->State->Pos.z - B->State->Pos.z;
				RelSpd.x = A->State->Spd.x - B->State->Spd.x;
				RelSpd.y = A->State->Spd.y - B->State->Spd.y;
				RelSpd.z = A->State->Spd.z - B->State->Spd.z;
				Landa.x = VecSqModule(RelSpd);//a
				Landa.y = 2.0*(RelSpd.x*RelPos.x+RelSpd.y*RelPos.y+RelSpd.z*RelPos.z);//b
				//c
				Landa.z = VecSqModule(RelPos) - (B->Body->Radius*B->Body->Radius);
				if((distance = ((Landa.y*Landa.y)-4*(Landa.x*Landa.z))) >= 0)
				{
					distance = sqrt(distance);
					Dimension.x = (-Landa.y + distance)/(2*Landa.x);
					Dimension.y = (-Landa.y - distance)/(2*Landa.x);
					if((Dimension.x > 0)&&(Dimension.x < gameTime()))return 1;
					if((Dimension.y > 0)&&(Dimension.y < gameTime()))return 1;
				}
				return 0;
			case Box:
				guMtxInverse(B->State->modMtx, Aux);
				guVecMultiply(Aux, &(A->State->Pos),&RelPos);//Calculamos la posicion relativa
				Dimension = (Vector){B->Body->Width*0.5,B->Body->Length*0.5,B->Body->Height*0.5};
				//Teorema de los ejes divergentes aqui tambien
				if(valAbs(RelPos.x) > Dimension.x) return 0;
				if(valAbs(RelPos.y) > Dimension.y) return 0;
				if(valAbs(RelPos.z) > Dimension.z) return 0;
				return 1;
		}
	case Sphere:
		switch(B->Body->type){
			case Point:
				return collide(B, A);
			case Sphere:
				RelPos.x = A->State->Pos.x - B->State->Pos.x;
				RelPos.y = A->State->Pos.y - B->State->Pos.y;
				RelPos.z = A->State->Pos.z - B->State->Pos.z;
				RelSpd.x = A->State->Spd.x - B->State->Spd.x;
				RelSpd.y = A->State->Spd.y - B->State->Spd.y;
				RelSpd.z = A->State->Spd.z - B->State->Spd.z;
				Landa.x = VecSqModule(RelSpd);//a
				Landa.y = 2.0*(RelSpd.x*RelPos.x+RelSpd.y*RelPos.y+RelSpd.z*RelPos.z);//b
				//c
				tRadius = B->Body->Radius+A->Body->Radius;
				Landa.z = VecSqModule(RelPos) - tRadius*tRadius;
				if((distance = ((Landa.y*Landa.y)-4*(Landa.x*Landa.z))) >= 0)
				{
					distance = sqrt(distance);
					Dimension.x = (-Landa.y + distance)/(2*Landa.x);
					Dimension.y = (-Landa.y - distance)/(2*Landa.x);
					if((Dimension.x > 0)&&(Dimension.x < gameTime()))return 1;
					if((Dimension.y > 0)&&(Dimension.y < gameTime()))return 1;
				}
				return 0;
			case Box:////////Esfera contra ortohedro
				guMtxInverse(B->State->modMtx, Aux);
				guVecMultiply(Aux, &(A->State->Pos),&RelPos);//Calculamos la posicion relativa
				Dimension = (Vector){B->Body->Width*0.5,B->Body->Length*0.5,B->Body->Height*0.5};
				if((RelPos.x = valAbs(RelPos.x)) < Dimension.x) RelPos.x = 0;
				else RelPos.x -= Dimension.x;
				if((RelPos.y = valAbs(RelPos.y)) < Dimension.y) RelPos.y = 0;
				else RelPos.y -= Dimension.y;
				if((RelPos.z = valAbs(RelPos.z)) < Dimension.z) RelPos.z = 0;
				else RelPos.z -= Dimension.z;
				if(VecSqModule(RelPos) < A->Body->Radius*A->Body->Radius)
				{
					return 1;
				}
				break;
			
		}
		break;
	case Box:
		switch(B->Body->type){
			case Point:
				return collide(B,A);
			case Sphere:
				return collide(B,A);
			case Box:
				Dimension = (Vector){A->Body->Width*0.5,A->Body->Length*0.5,A->Body->Height*0.5};
				guMtxInverse(B->State->modMtx, Aux);
				guVecMultiply(Aux,&(A->State->Pos),&RelPos);
				Min = RelPos;
				Max = RelPos;
				for(i = -1;i<2;i+=2)
				{
					for(j = -1;j<2;j+=2)
					{
						for(k = -1;k<2;k+=2)
						{
							Auxv.x = i*Dimension.x;
							Auxv.y = j*Dimension.y;
							Auxv.z = k*Dimension.z;
							guVecMultiply(A->State->modMtx,&Auxv,&Auxv);
							guVecMultiply(Aux,&Auxv,&Auxv);
							if(Auxv.x < Min.x) Min.x = Auxv.x;
							if(Auxv.y < Min.y) Min.y = Auxv.y;
							if(Auxv.z < Min.z) Min.z = Auxv.z;
							
							if(Auxv.x > Max.x) Max.x = Auxv.x;
							if(Auxv.y > Max.y) Max.y = Auxv.y;
							if(Auxv.z > Max.z) Max.z = Auxv.z;
						}
					}
				}
				Dimension = (Vector){B->Body->Width,B->Body->Length,B->Body->Height};
				if((Min.x > Dimension.x*0.5)&&(Max.x > Dimension.x*0.5))return 0;
				if((Min.y > Dimension.y*0.5)&&(Max.y > Dimension.y*0.5))return 0;
				if((Min.z > Dimension.z*0.5)&&(Max.z > Dimension.z*0.5))return 0;
				
				if((Min.x < -Dimension.x*0.5)&&(Max.x < -Dimension.x*0.5))return 0;
				if((Min.y < -Dimension.y*0.5)&&(Max.y < -Dimension.y*0.5))return 0;
				if((Min.z < -Dimension.z*0.5)&&(Max.z < -Dimension.z*0.5))return 0;
				//
				Dimension = (Vector){B->Body->Width*0.5,B->Body->Length*0.5,B->Body->Height*0.5};
				guMtxInverse(A->State->modMtx, Aux);
				guVecMultiply(Aux,&(B->State->Pos),&RelPos);
				Min = RelPos;
				Max = RelPos;
				for(i = -1;i<2;i+=2)
				{
					for(j = -1;j<2;j+=2)
					{
						for(k = -1;k<2;k+=2)
						{
							Auxv.x = i*Dimension.x;
							Auxv.y = j*Dimension.y;
							Auxv.z = k*Dimension.z;
							guVecMultiply(B->State->modMtx,&Auxv,&Auxv);
							guVecMultiply(Aux,&Auxv,&Auxv);
							if(Auxv.x < Min.x) Min.x = Auxv.x;
							if(Auxv.y < Min.y) Min.y = Auxv.y;
							if(Auxv.z < Min.z) Min.z = Auxv.z;
							
							if(Auxv.x > Max.x) Max.x = Auxv.x;
							if(Auxv.y > Max.y) Max.y = Auxv.y;
							if(Auxv.z > Max.z) Max.z = Auxv.z;
						}
					}
				}
				Dimension = (Vector){A->Body->Width,A->Body->Length,A->Body->Height};
				if((Min.x > Dimension.x*0.5)&&(Max.x > Dimension.x*0.5))return 0;
				if((Min.y > Dimension.y*0.5)&&(Max.y > Dimension.y*0.5))return 0;
				if((Min.z > Dimension.z*0.5)&&(Max.z > Dimension.z*0.5))return 0;
				
				if((Min.x < -Dimension.x*0.5)&&(Max.x < -Dimension.x*0.5))return 0;
				if((Min.y < -Dimension.y*0.5)&&(Max.y < -Dimension.y*0.5))return 0;
				if((Min.z < -Dimension.z*0.5)&&(Max.z < -Dimension.z*0.5))return 0;
				return 1;
		}
	break;
	}
	return 0;
}

void setSpeed(OBJECT* object, Vector Linear, Vector Angular)
{
	object->State->Spd = Linear;
	object->State->ASp = Angular;
}

f32 valAbs(f32 src)
{
	if(src < 0)
	return -src;
	else return src;
}

void UpdtTime()
{
	current_time = (f32)(ticks_to_millisecs(gettime()));
	if(last_frame) frame_time = current_time - last_frame;
	else frame_time = 0;
	last_frame = current_time;
	frame_time /= 1000.0;
}
