/////////////////////////////////////////////////
//Revolution Engine.
//by Technik
/////////////////////////////////////////////////

#include "REV.h"

////////////////////
//Esta macro esta tomada directamente de libgc, no es parte de revolution engine.
#define _SHIFTL(v, s, w)	\
    ((u32) (((u32)(v) & ((0x01 << (w)) - 1)) << (s)))
////////////////////

#define screenW 640
#define screenH 480

extern ROOT * mainRoot;

void update2D()
{
	PANEL * Aux;
	/////////////
	Aux = (PANEL*)mainRoot->FstPnl;
	while(Aux)
	{
		if(Aux->Visible)
		drawPnl(Aux);
		Aux = (PANEL*)Aux->next;
	}
}

void drawPnl(PANEL * panel)
{
	Vector zAxis = (Vector){0.0,0.0,1.0};
	switch(panel->type)
	{
		case PanelT:
		{
			Mtx PnlMtx;
			GX_LoadTexObj(panel->img, GX_TEXMAP0);
			guMtxIdentity(PnlMtx);
			guMtxRotAxisRad(PnlMtx,&zAxis,panel->angle);
			guMtxTransApply(PnlMtx, PnlMtx, panel->x, panel->y, 0.0);
			GX_LoadPosMtxImm(PnlMtx, GX_PNMTX0);
			GX_Begin(GX_QUADS, GX_VTXFMT0, 4);
				GX_Position3f32(0.0,0.0,-5.0);
				GX_Color4u8(255,255,255,255);
				GX_TexCoord2f32(panel->xstart,panel->ystart);
				
				GX_Position3f32(0.0,panel->sizeY,-5.0);
				GX_Color4u8(255,255,255,255);
				GX_TexCoord2f32(panel->xend,panel->ystart);
				
				GX_Position3f32(panel->sizeX,panel->sizeY,-5.0);
				GX_Color4u8(255,255,255,255);
				GX_TexCoord2f32(panel->xend,panel->yend);
				
				GX_Position3f32(panel->sizeX,0.0,-5.0);
				GX_Color4u8(255,255,255,255);
				GX_TexCoord2f32(panel->xstart,panel->yend);
			GX_End();
			break;
		}
		case TextT:
		{
			TEXT * text = (TEXT*)panel;
			DrawText (text->x,text->y,text->content);
			break;
		}
	}
}

void addPnl(PANEL * panel)//No layer yet
{
	PANEL * Aux = (PANEL*)mainRoot->FstPnl;
	if(Aux)
	{
		while(Aux->next)
		{
			if(panel->layer > ((PANEL*)Aux->next)->layer)
				Aux = Aux->next;
			else break;
		}
		panel->next = Aux->next;
		Aux->next = panel;
	}
	else mainRoot->FstPnl = panel;
}

struct REV_Panel * newPanel(GXTexObj * img, f32 xPos, f32 yPos, u16 sizeX, u16 sizeY, u8 layer, u8 flags)
{
	PANEL * Panel = (PANEL*)malloc(sizeof(PANEL));
	Panel->img = img;
	Panel->x = xPos;
	Panel->y = yPos;
	Panel->xstart = 0;
	Panel->xend = 1;
	Panel->ystart = 0;
	Panel->yend = 1;
	Panel->layer = layer;
	Panel->flags = flags;
	Panel->type = PanelT;
	Panel->angle = 0;
	Panel->sizeX = sizeX;
	Panel->sizeY = sizeY;
	Panel->next = NULL;
	addPnl(Panel);
	return Panel;
}

struct REV_Text * newText(char * content, f32 x, f32 y,GXColor Color, u8 size, u8 layer, u8 flags)
{
	TEXT * Text = (TEXT*)malloc(sizeof(TEXT));
	Text->next = NULL;
	Text->type = TextT;
	Text->layer = layer;
	Text->flags = flags;
	Text->x = x;
	Text->y = y;
	Text->size = size;
	strcpy(Text->content, content);
	Text->color = (GXColor){255,255,255,255};
	addPnl((PANEL*)Text);
	return Text;
}

GXColor REV_PeekARGB( u16 x, u16 y)
{
	u32 pixel;
	GXColor color;
	u8 a;
	pixel = 0xc8000000|(_SHIFTL(x,2,10));
	pixel = (pixel&~0x3FF000)|(_SHIFTL(y,12,10));
	color = (GXColor)(*(GXColor*)pixel);
	a = color.r;
	color.r = color.g;
	color.g = color.b;
	color.b = color.a;
	color.a = a;
	return color;
}
