/////////////////////////////////////////////////
//Revolution Engine.
//by Technik
/////////////////////////////////////////////////

#include "REV.h" // incluir todos los encabezamientos del motor.

void SetPos(OBJECT * object, Vector Pos)
{
	Vector Pos0 = (Vector){Pos.x - object->State->Pos.x,
							Pos.y - object->State->Pos.y,
							Pos.z - object->State->Pos.z};
	guMtxTransApply(object->State->modMtx, object->State->modMtx, Pos0.x, Pos0.y, Pos0.z);
	object->State->Pos = Pos;
}

void SetAng(OBJECT * object, Vector Ang)
{
	Vector Pos  = object->State->Pos;
	Mtx Aux;
	guMtxIdentity(object->State->modMtx);
	guMtxRotDeg(Aux, 'y', Ang.y);
	guMtxConcat(Aux, object->State->modMtx, object->State->modMtx);
	guMtxRotDeg(Aux, 'x', Ang.x);
	guMtxConcat(Aux, object->State->modMtx, object->State->modMtx);
	guMtxRotDeg(Aux, 'z', Ang.z);
	guMtxConcat(Aux, object->State->modMtx, object->State->modMtx);
	guMtxTransApply(object->State->modMtx, object->State->modMtx, Pos.x, Pos.y, Pos.z);
}

void Move(OBJECT * object, Vector Relative, Vector Absolute)
{
	Vector Pos0 = object->State->Pos;
	guMtxTransApply(object->State->modMtx, object->State->modMtx, -Pos0.x, -Pos0.y, -Pos0.z);
	guVecMultiply(object->State->modMtx, &Relative, &Relative);
	Pos0.x += Absolute.x + Relative.x;
	Pos0.y += Absolute.y + Relative.y;
	Pos0.z += Absolute.z + Relative.z;
	guMtxTransApply(object->State->modMtx, object->State->modMtx, Pos0.x, Pos0.y, Pos0.z);
	object->State->Pos = Pos0;
}

void Rotate(OBJECT * object, Vector Ang)
{
	Vector Pos0 = object->State->Pos;
	Mtx Aux;
	guMtxTransApply(object->State->modMtx, object->State->modMtx, -Pos0.x, -Pos0.y, -Pos0.z);
	guMtxRotDeg(Aux, 'y', Ang.y);
	guMtxConcat(Aux, object->State->modMtx, object->State->modMtx);
	guMtxRotDeg(Aux, 'x', Ang.x);
	guMtxConcat(Aux, object->State->modMtx, object->State->modMtx);
	guMtxRotDeg(Aux, 'z', Ang.z);
	guMtxConcat(Aux, object->State->modMtx, object->State->modMtx);
	guMtxTransApply(object->State->modMtx, object->State->modMtx, Pos0.x, Pos0.y, Pos0.z);
}
